
package de.ivu.elect.business.wahl.boundary;

import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Event;
import javax.inject.Inject;
import javax.inject.Named;


import de.ivu.elect.business.wahl.entity.Wahl;

@RequestScoped
@Named(WahlSessionSelect.COMPONENT_NAME)
public class WahlSessionSelect implements java.io.Serializable  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlSessionSelect";

  @Inject
  protected transient WahlExtendedDAO entityDAO;

  @Inject
  protected transient WahlSessionStore sessionStore;

  @Inject
  protected transient Event<WahlSelectChangeEvent> entitySelectChangeEvent;

  private transient Boolean selectedCache = null;

  public WahlSessionSelect() {
    super();
  }

  public boolean isSelected() {
    if (selectedCache == null) { // NPE beim Löschen von Entitäten verhindern
      if (getEntityPK() == null) {
        selectedCache = false;
      } else {
        selectedCache = getEntity() != null;
      }
    }

    return selectedCache;
  }

  public Wahl getEntity() {
    return getEntityInternal();
  }

  private Wahl getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Wahl entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.wahl.entity.WahlPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Wahl entity) {
    if (entity == null && getEntityPK() != null) {
      changeEntityPkFireEvent(null, null);
    } else if (entity != null && !entity.getPk().equals(getEntityPK())) {
      if (isSetzenErlaubt(entity)){
        changeEntityPkFireEvent(entity, entity.getPk());
      }
    }
  }

  public
    de.ivu.elect.business.wahl.entity.WahlPK
   getEntityPK() {
    return sessionStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.wahl.entity.WahlPK
   entityPK) {
    selectedCache = null;
    sessionStore.setEntityPK(entityPK);
  }

  protected Wahl attach(Wahl entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Wahl attach( de.ivu.elect.business.wahl.entity.WahlPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public boolean isSetzenErlaubt(Wahl entity) {
    return true; // Überschreiben, wenn etwas geprüft werden soll...
  }

  private void changeEntityPkFireEvent(Wahl neueEntity,
    de.ivu.elect.business.wahl.entity.WahlPK
    neueEntityPK) {
    final Wahl alteEntity = getEntityInternal();
    setEntityPK(neueEntityPK);
    entitySelectChangeEvent.fire(new WahlSelectChangeEvent(alteEntity, neueEntity));
  }
}
